bind pub - ${pub_prefix}credits cts:credits
bind msg - transfer cts:transfer
proc adjcreds {user amt sitename} { global cts enabled
	if { $enabled(debug) } {putlog "$cts(progname): adjcreds $user $amt $sitename"}
	set ss 0
	foreach site [split $cts(sites)] {
		set n [split $site ':']
		if { [string tolower [lindex $n 0]]==[string tolower $sitename] } {
			set ss "$site"
			break
        	}
	}
	if ![info exists $ss] {
		set n [split $ss ':']
		set amt [expr $amt * 1024 * 1024 ]
		if {$amt > 0} {
			switch [string tolower [lindex $n 5]] {
				gl		{ set reply [[lindex $n 0]::Quote SITE GIVE $user $amt] }
				io		{ set reply [[lindex $n 0]::Quote SITE CHANGE $user credits +$amt] }
				ra		{ set amt [expr $amt/1024]; set reply [[lindex $n 0]::Quote SITE GIVE $user $amt] }
				default	{ set reply "error" }
			}
		} elseif {$amt < 0} {
			set amt [expr $amt * -1]
			switch [string tolower [lindex $n 5]] {
				gl		{ set reply [[lindex $n 0]::Quote SITE TAKE $user $amt] }
				io		{ set reply [[lindex $n 0]::Quote SITE CHANGE $user credits -$amt] }
				ra		{ set amt [expr $amt/1024]; set reply [[lindex $n 0]::Quote SITE TAKE $user $amt] }
				default	{ set reply "error" }
			}
		} else {
			set reply "error"
		}
		if { $enabled(debug) } {putlog "$cts(progname): adjcredts: reply=$reply"}
		if { $reply != "error" } {
			if { [regexp "200*" $reply] || [regexp "221*" $reply]} {
				return 1
			} else {
				return 0
			}
		} else {
			return 0
		}
	}
}

proc getucreds_gl {user sitename return_group} { global cts
  	set creds 0
	set group "NoGroup"
	set f 0
	foreach site [split $cts(sites)] {
		set n [split $site ':']
		if { [string tolower [lindex $n 0]]==[string tolower $sitename]} {
		  	set reply [[lindex $n 0]::Quote SITE USER $user]
			foreach line [split $reply "\n"] {
				set part1 [string range $line 0 41]
   				set line [string range $line 42 end]
				if {[lindex $part1 2] == "Ratio:" && [lindex $part1 3] == "Unlimited"} {
					set creds -1 ; incr f
   				} elseif {[lindex $line 0] == "Credits:"} {
					set creds [lindex $line 1]
   			 		set pos [string last "." $creds]
   					if {$pos != -1} {incr pos -1 ; set creds [string range $creds 0 $pos]}
   	   				incr f
				} elseif {[lindex $part1 2] == "Groups:"} {
					set group "[lindex $part1 3]"
					incr f
				} elseif { $part1 == "200 User '$user' does not exist." } {
					set creds -550 ; break
				} elseif {[lindex $part1 2] == "Flags:" && [regexp "6" [lindex $part1 3]]} {
					set creds -6 ; break
				}
				if { $f==3 } { break }
			}
 		}
	} 
	if {$return_group==1} {
	 	return "[expr int($creds)]|$group"
	} else {
		return [expr int($creds)]
	}
}

proc getucreds_ra {user sitename return_group} { global cts
	set creds 0
	set group "NoGroup"
	set f 0
	foreach site [split $cts(sites)] {
		set n [split $site ':']
		if { [string tolower [lindex $n 0]]==[string tolower $sitename]} {
  			set reply [split [[lindex $n 0]::Quote SITE USER $user] "\n"]
  			foreach line $reply {
				if { [lindex $line 1]=="ratio" && [lindex $line 3]=="Unlimited" } {
       				set creds -1 ; incr f
   				} elseif {[lindex $line 1] == "available" && [lindex $line 2] == "credit" } {
       				set creds [lindex $line 4]
					set pos [string last "b" $creds]
   	    			if {$pos != -1} {incr pos -2 ; set creds [string range $creds 0 $pos]}
					switch [lindex $line 5] {
						tb			{ set creds [expr $creds*1024*1024] }
						gb			{ set creds [expr $creds*1024] }
						default		{ set creds $creds }
					}
					incr f
   				} elseif {[lindex $line 1] == "group"} {
   					set group "[lindex $line 3]"
   					incr f
   				} elseif {[lindex $line 0] == "550"} {
					set creds -550 ; break
				}
				if { $f == 3 } { break }
			}
		}
  	}
	if {$return_group==1} {
	 	return "[expr int($creds)]|$group"
	} else {
		return [expr int($creds)]
	}
}

proc getucreds_io {user sitename return_group} { global cts
	set creds 0
	set group "NoGroup"
   	set f 0
	foreach site [split $cts(sites)] {
		set n [split $site ':']
		if { [string tolower [lindex $n 0]]==[string tolower $sitename]} {
  			set reply [split [[lindex $n 0]::Quote SITE UINFO $user] "\n"]
  			foreach line $reply {
				if { [lindex $line 1]=="Ratio" && [lindex $line 3]=="Unlimited" } {
       					set creds -1 ; incr f
   				} elseif {[lindex $line 1] == "Credits:"} {
       					set creds [lindex $line 2]
	       				set pos [string last "MB" $creds]
   	    				if {$pos != -1} {incr pos -1 ; set creds [string range $creds 0 $pos]}
   						incr f
   				} elseif {[lindex $line 3] == "Group:"} {
   						set group "[lindex $line 4]"
   						incr f
				} elseif {[lindex $line 0] == "550"} {
					set creds -550 ; break
				}
   				if {$f==3} { break }
			}
		}
  	}
	if {$return_group==1} {
	 	return "[expr int($creds)]|$group"
	} else {
		return [expr int($creds)]
	}
}

proc cts:credits {nick uhost hand chan ar} { global cts
	set text [split $ar]
	set us [lindex $text 0]
	set total 0
	set numsites 0
	foreach site [split $cts(sites)] {
		set n [split $site ':']
		if ![catch [[lindex $n 0]::Noop]] {
			set message "[b][lindex $n 0][b] is not linked at the moment."
		} else {
			set reply [getucreds_[lindex $n 5] $us [lindex [split $site ':'] 0] 1]
			set val [lindex [split $reply '|'] 0]
			if  { $val == -1 } {
				set group [lindex [split $reply '|'] 1]
				set message "On [lindex $n 0] [b]$us[b]/[b]$group[b] has [b]LEECH[b]"
			} elseif { $val == -550 } {
				set message "On [lindex $n 0] [b]$us[b] doesn't yet have a account."
			} elseif { $val == -6 } {
				set message "On [lindex $n 0] [b]$us[b] has been [b]deleted[b]."
			} else {
				set group [lindex [split $reply '|'] 1]
				set total [expr $total+$val]
				incr numsites
				set message "On [lindex $n 0] [b]$us[b]/[b]$group[b] has [expr $val/1024] gB"
			}
		}
		hubsend chan 5 $nick NOTICE $message
	}
	hubsend chan 5 $nick NOTICE "[b]$us[b]/[b]$group[b] has [b][expr int($total/1024)] gB[b] on $numsites sites."
}

proc cts:transfer { nick uhost hand text } { global cts	
	set com [split $text]	
	set login [lindex $com 0]	
	set passw [lindex $com 1]	
	set from [lindex $com 2]	
	set to [lindex $com 3]	
	set amt [lindex $com 4]
	if { [cts:validate_user $login $passw]==-1 } {
			hubsend chan 5 $nick "Sorry wrong credentials given..Bye bye"
			return 0
	}	
	foreach site [split $cts(sites)] {
		set n [split $site ':']
		if { [string tolower [lindex $n 0]]==[string tolower $to] } {
			set to_credits [getucreds_[lindex $n 5] $login $to 0]
		}
		if { [string tolower [lindex $n 0]]==[string tolower $from] } {
			set from_credits [getucreds_[lindex $n 5] $login $from 0]
		}
	}
	if { [expr $from_credits/1024] > $amt } {
		hubsend msg 5 $nick PRIVMSG "You have [expr $from_credits/1024]gB on $from."
	} else {
		hubsend msg 5 $nick PRIVMSG "Sorry [expr $from_credits-$amt]gB missing on $from. UPLOAD!!!"
		return -1
	}	
	if { $to_credits < 0 } {
		hubsend msg 5 $nick PRIVMSG "Sorry something wrong with $to.  :("
		return -1	
	}
	if [adjcreds $login -$amt $from] { 
#		hubsend msg 5 $nick PRIVMSG "Removed [expr $amt]gB from $from"
	} else {
		hubsend msg 5 $nick PRIVMSG "Hmm something went wrong..stopping everything /pm a siteop for help"
		return 0
	}  
	if [adjcreds $login $amt $to] {
#		hubsend msg 5 $nick PRIVMSG "Added $amt gB to $to"
	} else {
		hubsend msg 5 $nick PRIVMSG "Can't add credits to $to. Restoring credits on $from."
		adjcreds $login $amt $from
		return -1
	}
	hubsend msg 5 $nick PRIVMSG "Moved $amt gB from $from to $to, happy downloading"
}
