bind pub - ${pub_prefix}passed cts:passed
bind pub - ${pub_prefix}filter cts:filter
bind pub - ${pub_prefix}monthup cts:MonthUp

proc getuploaded {user sitename} { global cts enabled
	set Uploaded -1
	set group "NotFound"
	set val 0
	foreach site [split $cts(sites)] {
		set n [split $site ':']
		if {[string tolower [lindex $n 0]]==[string tolower $sitename]} {
			switch [lindex $n 5] {
				gl {
					set reply [split [[lindex $n 0]::Quote SITE SHOW $user] "\n"]
					foreach line $reply {
						if { $line == "200 User '$user' does not exist." } {
								set Uploaded -550
								break
						}
						if {[lindex $line 1]=="MONTHUP"} {
							if { [lindex $line 3] != 0 } {
								set Uploaded [expr [lindex $line 3]/1024]
							} else {
								set Uploaded 0
							}
							incr val
						} elseif {[lindex $line 1]=="GROUP"} {
							set group "[lindex $line 2]"
							incr val
						} 
						if { $val == 2 } { break }
					}
				}
				io {
					set reply [split [[lindex $n 0]::Quote SITE STATS MONTHUP LIMIT $user] "\n"]
					foreach line $reply {
						if { [regexp $user* $line] } {
							set Uploaded [string trim [lindex [split $line '|] 3]] 
							set group [string trim [lindex [split [lindex [split $line '@'] 1] '|'] 0]]
						}
					}
					if { $Uploaded == -1 && $group == "NotFound" } {
						set Uploaded -550
					}
				}
				ra {
					set Uploaded -1				
				}
				default {
					set Uploaded -1
				}
			}
		}
	}
	return "[string trim $Uploaded]|[string trim $group]"
}

proc cts:passed {nick uhost hand chan text} { global cts enabled
	set us [lindex [split $text] 0]
	set total 0
	set leech 0
	set numsites 0
	set nouser 0
	set message ""
	set group ""
	foreach site [split $cts(sites)] {
		set n [split $site ':']
		set reply [getuploaded $us [lindex $n 0]]
		if { [lindex [split $reply '|'] 0] != -550 } {
			incr numsites
			if { ![regexp [lindex [split [string tolower $reply] '|'] 1] [string tolower $group]] } {
				if {$group==""} { 
					set group "[lindex [split $reply '|'] 1]"
				} else {
					set group "$group,[lindex [split $reply '|'] 1]"
				}
			}
			set total [expr $total+[lindex [split $reply '|'] 0]]
			incr numsites
		} else {
			incr nouser
		}
	}

# Calculate days till quotaperiod ends

	set this_year [clock format [clock seconds] -format "%Y" -gmt true]
	set next_month [expr int([format %f [clock format [clock seconds] -format "%m" -gmt true]])+1]
	if {$next_month == 13} {
		set next_month 1
		set this_year [expr $this_year+1]
	}
	set next_month [clock scan "$next_month/01/$this_year 00:00:00"]
	set now [clock format [clock seconds] -format {%m/%d/%Y %H:%m:%S} -gmt true]
	set now [clock scan $now]
	set diff [expr $next_month-$now]
	set month_left [expr int(floor($diff/86400))]
	set trial_left [expr int(floor(($diff-(86400*$month_left))/3600))]

	set exempted 0
	foreach gr [split $cts(quotaexempt)] {
		if { [regexp [string tolower $gr] [string tolower $group]] } {
			set exempted 1
			break
		}
	}
	if { $total > $cts(quotamonth) } {
		set over_mb [expr int($total-$cts(quotamonth))]
		if { $total == 0 } { set total 1 }
		if { $exempted==1 } {
			set message "[b]\[EXEMPT\][b]: [b]$us[b] is in affiliated group [b]$group[b]. Had that not been the case then [b]$us[b] would have uploaded [b]$over_mb mB[b] above the monthly limit ([b]$cts(quotamonth) mB/month[b])."
		} else {
			set message "[b]\[PASSED\][b]: User [b]$us[b]/[b]$group[b] has uploaded [b][expr int($total-$cts(quotamonth))] mB[b] over the needed quota ([b]$cts(quotamonth) mB/month[b]). He can rest for [b]$month_left[b] days."
		}
	} elseif { $total < $cts(quotamonth) } {
		if { $total == 0 } { set total 1 }
		set missing_mb [expr int($cts(quotamonth)-$total)]
		if { $month_left != 0 } {
			set mb_day [expr int($missing_mb/$month_left)]
		} else {
			set mb_day [expr int($missing_mb)]
		}
		if { $exempted==1 } {
			set message "[b]\[EXEMPT\][b]: [b]$us[b] is in affiliated group [b]$group[b]. Had that not been the case then [b]$us[b] would be missing [b]$missing_mb mB[b] from the [b]$cts(quotamonth) mB[b]/[b]month[b] limit and $month_left days remaining, meaning [b]$mb_day mB/day[b]."
		} else {
			set message "[b]\[FAiLED\][b]: User [b]$us/$group[b] is missing [b]$missing_mb mB[b] ([b]$cts(quotamonth) mB[b]/[b]month[b]) and [b]$month_left[b] days remaining. Needs to upload an additional [b][expr int([expr $cts(quotamonth)-$total]/$month_left)] mB[b]/[b]day[b]."
		}
	}
	if { $numsites == 0 } {
			set message "[b]\[CTS ERROR\][b]: Sorry, seems like I can't find [b]$us[b] on any site."
	}
	if { $nouser > 0 && $numsites != 0 } {
		set message "$message Warning [b]$us[b] has no account on [b]$nouser[b] site(s)." 
	}	
	hubsend chan 5 $nick NOTICE $message
	if {$enabled(debug)} { putlog "$cts(progname): cts:passed ->announce $message" }
}

proc cts:filter {nick uhost hand chan text} { global cts enabled

}

proc cts:MonthUp {nick uhost hand chan text} { global cts enabled
	set us [lindex [split $text] 0]
	set output ""
	foreach site [split $cts(sites)] {
		set n [split $site ':']
		set reply [split [getuploaded $us [lindex $n 0]] '|]
		set message "[b]\[MonthUp\][b]: On [b][lindex $n 0][b]"
		if { [lindex $reply 0] >= 0 } {
			set message "$message has [b]$us[b]/[b][lindex $reply 1][b] uploaded [lindex $reply 0] mb."
		} elseif { [lindex $reply 0] == -550 } {
			set message "$message user [b]$us[b] has no account." 
		} else {
			set message "$message has a error occured, please try again later"
		}
		hubsend chan 5 $nick NOTICE $message
	}
}
